//-*-c++-*------------------------------------------------------------
//
// File name : bioMhRandomWalkTransition.h
// Author :    Michel Bierlaire
// Date :      Mon Aug  9 16:44:26 2010
//
//--------------------------------------------------------------------

#ifndef bioMhRandomWalkTransition_h
#define bioMhRandomWalkTransition_h

#include "bioMarkovProcess.h"
#include "patRandomWalk.h"

class bioMhDetourTransition ;
class bioMhPathGenState ;
class patUniform ;

/**
We replace the subpaths u->v and v->d by paths generated by
the random walk algorithm, the v is "theNode".

 */


class patNetwork ;

class bioMhRandomWalkTransition : public bioMarkovProcess {
 public:
  bioMhRandomWalkTransition(patNetwork* n, 
			    patReal a, 
			    patReal b,
			    patReal scale,
			    patUniform* rng) ;
  virtual bioMarkovTransition getNextState(bioMarkovState* currentState, 
					   patError*& err) ;

 private:  

  patRandomWalk theRandomWalkAlgo ;
  patNetwork* theNetwork ;
  bioMhPathGenState* currentState ;
  patReal theScale ;
  patUniform* theRng ;
  bioMhDetourTransition* theDetourProcess ;

};

#endif
