//-*-c++-*------------------------------------------------------------
//
// File name : bioGaussHermite.cc
// Author :    Michel Bierlaire
// Date :      Thu Apr  8 10:57:03 2010
//
//-------------------------------------------------------------------

#include "bioGaussHermite.h"

bioGaussHermite::bioGaussHermite(bioGhFunction* f) : theFunction(f) {

}

patReal bioGaussHermite::integrate() {

   double integral = 0.0;
   const double *pA = &A[NUM_OF_POSITIVE_ZEROS];
   const double *px;
   
   for (px = &x[NUM_OF_POSITIVE_ZEROS - 1]; px >= x; px--) 
      integral += *(--pA) * ( theFunction->getUnweightedValue(*px) + theFunction->getUnweightedValue(- *px) );

   return integral;

}

void bioGaussHermite::Gauss_Hermite_Coefs_100pts( double coef[]) {
   const double *pA = &A[NUM_OF_POSITIVE_ZEROS - 1];
   double *pc = &coef[NUM_OF_ZEROS - 1];

   for (; pA >= A; pA--)  {
      *(coef++) =  *pA;
      *(pc--) = *pA;
   }   
}

void bioGaussHermite::Gauss_Hermite_Zeros_100pts( double zeros[] ) {
  const double *px = &x[NUM_OF_POSITIVE_ZEROS - 1];
  double *pz = &zeros[NUM_OF_ZEROS - 1];
  
  for (; px >= x; px--)  {
    *(zeros++) = - *px;
      *(pz--) = *px;
  }   
}



