//-*-c++-*------------------------------------------------------------
//
// File name : bioArithAnd.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 10:34:04 2009
//
//--------------------------------------------------------------------

#ifndef bioArithAnd_h
#define bioArithAnd_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a logical and operation
*/
class bioArithAnd : public bioExpression {

public:
  
  bioArithAnd(bioExpression* par,
		          bioExpression* left, 
		          bioExpression* right) ;
  ~bioArithAnd() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithAnd* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
