//-*-c++-*------------------------------------------------------------
//
// File name : bioArithConstant.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Wed May  6 16:35:24 2009
//
//--------------------------------------------------------------------

#ifndef bioArithConstant_h
#define bioArithConstant_h

#include "bioExpression.h"
#include "patType.h"

/*!
Class implementing the node for numerical constants in an expression
*/

class bioArithConstant: public bioExpression {

public:
  bioArithConstant(bioExpression* par, patReal aValue) ;
  
 public:
  
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const ;
  virtual patReal getValue(patError*& err) const ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioExpression* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patBoolean isConstant() const ;
  virtual patULong getNumberOfOperations() const ;
  virtual patString getExpressionString() const  ;
  
 protected:

  patReal theValue ; 

};

#endif
