//-*-c++-*------------------------------------------------------------
//
// File name : bioArithDivide.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Apr 28 20:57:24 2009
//
//--------------------------------------------------------------------

#ifndef bioArithDivide_h
#define bioArithDivide_h


#include "bioExpression.h"

/*!
Class implementing a node for a division operation
*/
class bioArithDivide : public bioExpression {

public:
  
  bioArithDivide(bioExpression* par,
		 bioExpression* left, 
		 bioExpression* right) ;
  ~bioArithDivide() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId,
				       patError*& err) const ;
  virtual bioArithDivide* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  // The simpleCppCode does not work because we need to check if
  // numerator is zero before computing the ratio. A segmentation
  // fault is triggered. Did not have time to investigate more, so I
  // prefer to declare this expression has "not simple".
  virtual patBoolean isSimple() const ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patString getExpressionString() const ;
};

#endif
