//-*-c++-*------------------------------------------------------------
//
// File name : bioArithEqual.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:07:32 2009
//
//--------------------------------------------------------------------

#ifndef bioArithEqual_h
#define bioArithEqual_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (==) operation
*/
class bioArithEqual : public bioExpression {

public:
  
  bioArithEqual(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithEqual() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithEqual* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
