//-*-c++-*------------------------------------------------------------
//
// File name : bioArithExp.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 14:13:31 2009
//
//--------------------------------------------------------------------

#ifndef bioArithExp_h
#define bioArithExp_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing an exponential operation
*/
class bioArithExp : public bioExpression {

public:
  
  bioArithExp(bioExpression* par,
		          bioExpression* left) ;
  ~bioArithExp() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithExp* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
