//-*-c++-*------------------------------------------------------------
//
// File name : bioArithGreater.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:24:53 WEST 2009
//
//--------------------------------------------------------------------

#ifndef bioArithGreater_h
#define bioArithGreater_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (>) operation
*/
class bioArithGreater : public bioExpression {

public:
  
  bioArithGreater(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithGreater() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithGreater* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
