//-*-c++-*------------------------------------------------------------
//
// File name : bioArithIterator.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Jun 16 12:41:39 2009
//
//--------------------------------------------------------------------

#ifndef bioArithIterator_h
#define bioArithIterator_h


#include "bioLiteral.h"
#include "bioIteratorInfo.h"
#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a sum expression
*/
class bioArithIterator : public bioExpression {

public:
  
  bioArithIterator(bioExpression *par,
                           bioExpression *left,
                           bioIteratorInfo *anIterator) ;

  ~bioArithIterator() ;

public:
  virtual bioOperatorType getOperatorType() const = PURE_VIRTUAL;
  virtual patString getOperatorName() const = PURE_VIRTUAL ;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const = PURE_VIRTUAL ;
  virtual bioArithIterator* getDeepCopy(patError*& err) = PURE_VIRTUAL ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpression(patError*& err) const ;
  virtual patBoolean isSimple() const ;
  virtual bioIteratorInfo* theIterator() ;
  virtual patULong getNumberOfOperations() const ;

  virtual patBoolean isSum() const = PURE_VIRTUAL ;
  virtual patBoolean isProd() const = PURE_VIRTUAL ;
  virtual void simplifyLowerIteratorOrSequence(patError*& err) ;
protected:

  bioIteratorInfo* theIteratorInfo ;

};

#endif
