//-*-c++-*------------------------------------------------------------
//
// File name : bioArithLess.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:28:36 2009
//
//--------------------------------------------------------------------

#ifndef bioArithLess_h
#define bioArithLess_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (<) operation
*/
class bioArithLess : public bioExpression {

public:
  
  bioArithLess(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithLess() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithLess* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
