//-*-c++-*------------------------------------------------------------
//
// File name : bioArithMax.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Sat Feb  6 16:47:16 2010
//
//--------------------------------------------------------------------

#ifndef bioArithMax_h
#define bioArithMax_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a max operation
*/
class bioArithMax : public bioExpression {

public:
  
  bioArithMax(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithMax() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithMax* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
