//-*-c++-*------------------------------------------------------------
//
// File name : bioArithMin.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Sat Feb  6 16:50:49 2010
//
//--------------------------------------------------------------------

#ifndef bioArithMin_h
#define bioArithMin_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a max operation
*/
class bioArithMin : public bioExpression {

public:
  
  bioArithMin(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithMin() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithMin* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
