//-*-c++-*------------------------------------------------------------
//
// File name : bioArithMult.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Apr 28 20:41:16 2009
//
//--------------------------------------------------------------------

#ifndef bioArithMult_h
#define bioArithMult_h


#include "bioExpression.h"

/*!
Class implementing a node for a multiplication operation
*/
class bioArithMult : public bioExpression {

public:
  
  bioArithMult(bioExpression* par,
	       bioExpression* left, 
	       bioExpression* right) ;
  ~bioArithMult() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteral, 
				       patError*& err) const ;
  virtual bioArithMult* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patBoolean isSimple() const ;
  virtual patString getExpressionString() const ;
};

#endif
