//-*-c++-*------------------------------------------------------------
//
// File name : bioArithNotEqual.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 11:40:41 2009
//
//--------------------------------------------------------------------

#ifndef bioArithNotEqual_h
#define bioArithNotEqual_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a comparison (!=) operation
*/
class bioArithNotEqual : public bioExpression {

public:
  
  bioArithNotEqual(bioExpression* par,
		            bioExpression* left,
		            bioExpression* right) ;
  ~bioArithNotEqual() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteral, 
				       patError*& err) const ;
  virtual bioArithNotEqual* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
