//-*-c++-*------------------------------------------------------------
//
// File name : bioArithOr.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue May  5 10:44:36 2009
//
//--------------------------------------------------------------------

#ifndef bioArithOr_h
#define bioArithOr_h


#include "bioExpression.h"

/*!
Class implementing a node of the tree representing a logical or operation
*/
class bioArithOr : public bioExpression {

public:
  
  bioArithOr(bioExpression* par,
		         bioExpression* left, 
		         bioExpression* right) ;
  ~bioArithOr() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual patReal getValue(patError*& err) const  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithOr* getDeepCopy(patError*& err) ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patString getExpressionString() const ;
};

#endif
