//-*-c++-*------------------------------------------------------------
//
// File name : bioArithPrint.h
// Author :    Michel Bierlaire
// Date :      Tue May 11 07:08:49 2010
//
//--------------------------------------------------------------------

#ifndef bioArithPrint_h
#define bioArithPrint_h


#include "bioArithIterator.h"
#include "bioLiteral.h"
#include "bioIteratorInfo.h"


/*!
Class implementing a node of the tree design to print the values of expressions
*/
class bioArithPrint : public bioArithIterator {

public:
  
  bioArithPrint(bioExpression *par,
		map<patString,bioExpression*> theTerms,
		bioIteratorInfo *anIterator) ;

  ~bioArithPrint() ;

public:
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual patBoolean isSum() const  ;
  virtual patBoolean isProd() const  ;
  virtual bioOperatorType getOperatorType() const;
  virtual patString getExpression(patError*& err) const ;
  virtual patString getOperatorName() const ;
  virtual bioArithPrint* getDeepCopy(patError*& err) ;
  virtual patString getExpressionString() const ;
  virtual patULong getNumberOfOperations() const ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual void generateGslFunctions(ostream& str_h,patString prefix,patError*& err) ;

private:
  map<patString,bioExpression*> theExpressions ;

};

#endif

