//-*-c++-*------------------------------------------------------------
//
// File name : bioArithProd.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Wed Jul  8 15:06:48  2009
//
//--------------------------------------------------------------------

#ifndef bioArithProd_h
#define bioArithProd_h


#include "bioArithIterator.h"


/*!
Class implementing a node of the tree representing a product expression
*/
class bioArithProd : public bioArithIterator {

public:
  
  bioArithProd(bioExpression* par,
	       bioExpression* left,
	       bioIteratorInfo* anIterator) ;
  ~bioArithProd() ;

public:
  virtual bioOperatorType getOperatorType() const ;
  virtual patString getOperatorName() const;
  virtual bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  virtual bioArithProd* getDeepCopy(patError*& err) ;
  virtual patBoolean isSum() const  ;
  virtual patBoolean isProd() const  ;
  virtual patString getExpressionString() const ;


};

#endif
