//-*-c++-*------------------------------------------------------------
//
// File name : bioArithRandom.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Thu Jul 30 17:19:12 2009
//
//--------------------------------------------------------------------

#include "bioArithRandom.h"
#include "bioArithConstant.h"
#include "patDisplay.h"
#include "patErrMiscError.h"
#include "bioRandomDraws.h"
#include "bioLiteralRepository.h"

bioArithRandom::bioArithRandom(bioExpression* par, 
			       patULong i, 
			       patString t,
			       patULong index) :
  bioExpression(par,NULL,NULL),
  id(i),
  type(t),
  indexId(index) {

}
bioArithRandom::~bioArithRandom() {
} ;

bioExpression::bioOperatorType bioArithRandom::getOperatorType() const {
  return RANDOM_OP ;
}

patString bioArithRandom::getOperatorName() const {
  stringstream str ;
  str << type << "(" << indexId << ")" ;
  return patString(str.str()) ;
}

patReal bioArithRandom::getValue(patError*& err) const {
  err = new patErrMiscError("Not yet implemented") ;
  WARNING(err->describe()) ;
  return patReal() ;
}

bioExpression* bioArithRandom::getDerivative(patULong aLiteralId, patError*& err) const {
  bioArithConstant* result = new bioArithConstant(NULL,0) ;
  return result ;
}

bioArithRandom* bioArithRandom::getDeepCopy(patError*& err) {
  bioArithRandom* theNewNode = new bioArithRandom(NULL,id,type,indexId) ;
  return theNewNode ;

}

patString bioArithRandom::getSimpleCppCode(patError*& err) {
  stringstream str ;
  str << "(*__draw)[ " << id << "][patULong(" <<bioLiteralRepository::the()->getCppCode(indexId,err) << ")]" ;
  return patString(str.str()) ;
    
}

patString bioArithRandom::getCppCode(patString prefix, patError*& err) {
  if (codeMustBeGenerated) {
  stringstream str  ;
  str << getCppResultDeclaration(prefix) << "=" <<  getSimpleCppCode(err) << " ;" << endl ;
  if (err != NULL) {
    WARNING(err->describe()) ;
    return patString() ;
  }
  //  str << "DEBUG_MESSAGE(\"" << getCppResult(prefix) << "= \" << " << getCppResult(prefix) << ");" << endl ;
  codeMustBeGenerated = patFALSE ;
  return patString(str.str()) ;
  }
  else {
    return patString() ;
  }
}

patULong bioArithRandom::getNumberOfOperations() const {
  return 0 ;
}

patString bioArithRandom::getExpressionString() const {
  stringstream str ;
  str << "&" << id ;
  return patString(str.str()) ;

}
