//-*-c++-*------------------------------------------------------------
//
// File name : bioArithRandom.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Thu Jul 30 17:13:52 2009
//
//--------------------------------------------------------------------

#ifndef bioArithRandom_h
#define bioArithRandom_h

#include "bioExpression.h"

/*!
Class defining an interface for a random parameter
*/

class bioArithRandom : public bioExpression {

public:

  bioArithRandom(bioExpression* par, patULong id, patString type,patULong index) ;
  ~bioArithRandom() ;
  bioOperatorType getOperatorType() const ;
  patString getOperatorName() const  ;
  patReal getValue(patError*& err) const ;
  bioExpression* getDerivative(patULong aLiteralId, patError*& err) const ;
  bioArithRandom* getDeepCopy(patError*& err) ;
  patString getSimpleCppCode(patError*& err)  ;
  patString getCppCode(patString prefix, patError*& err)  ;
  patULong getNumberOfOperations() const ;
  patString getExpressionString() const  ;


protected:
  patULong id ;
  patString type ;
  // Id of the variable which defines the number of draws
  // needed. Typically, the id of the individual or the id of the row.
  patULong indexId ;

};


#endif
