//-*-c++-*------------------------------------------------------------
//
// File name : bioArithSum.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Jun 16 12:41:39 2009
//
//--------------------------------------------------------------------

#ifndef bioArithSum_h
#define bioArithSum_h


#include "bioArithIterator.h"
#include "bioLiteral.h"
#include "bioIteratorInfo.h"


/*!
Class implementing a node of the tree representing a sum expression
*/
class bioArithSum : public bioArithIterator {

public:
  
  bioArithSum(bioExpression *par,
                           bioExpression *left,
                           bioIteratorInfo *anIterator) ;

  ~bioArithSum() ;

public:
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual patBoolean isSum() const  ;
  virtual patBoolean isProd() const  ;
  virtual bioOperatorType getOperatorType() const;
  virtual patString getOperatorName() const ;
  virtual bioArithSum* getDeepCopy(patError*& err) ;
  virtual patString getExpressionString() const ;

  

};

#endif
