//-*-c++-*------------------------------------------------------------
//
// File name : bioExpressionRepository.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Sat Sep 12 16:03:17 2009
//
//--------------------------------------------------------------------
#include <sstream>
#include "bioExpressionRepository.h"

bioExpressionRepository* bioExpressionRepository::the() {
  static bioExpressionRepository* singleInstance = NULL ;

  if (singleInstance==NULL) {
    singleInstance = new bioExpressionRepository ;
  }
  return singleInstance ;
}

bioExpressionRepository::bioExpressionRepository() {

}

patULong bioExpressionRepository::addExpression(bioExpression* exp) {
  theRepository.push_back(exp) ;
  return (theRepository.size()-1) ;
}

bioExpression* bioExpressionRepository::getExpression(patULong id) {
  if (id >= theRepository.size()) {
    return NULL ;
  }
  return theRepository[id] ;
}

patString bioExpressionRepository::printList() {
  stringstream str ;
  for (patULong i = 0 ; i < theRepository.size() ; ++i) {
    str << "[" << i << "] " << *(theRepository[i]) << endl ;
  }
  return patString(str.str()) ;
}
