//-*-c++-*------------------------------------------------------------
//
// File name : bioIteratorFactory.cc
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Thu Jul 16 09:48:02 2009
//
//--------------------------------------------------------------------

#include <sstream>
#include "patDisplay.h"
#include "bioIteratorFactory.h"
#include "bioIteratorInfo.h"


bioIteratorFactory::bioIteratorFactory() {
  repository = bioIteratorInfoRepository::the() ;
}


bioIteratorFactory* bioIteratorFactory::the() {
  static bioIteratorFactory* singleInstance = NULL ;
  if (singleInstance == NULL) {
    singleInstance = new bioIteratorFactory ;
  }
  return singleInstance ;
}


patString bioIteratorFactory::getCppCode(patError*& err) {
  stringstream str ;

  map<patString,bioIteratorInfo> iterInfoRep = repository->getRepository() ;
  for (map<patString,bioIteratorInfo>::const_iterator it = iterInfoRep.begin() ;
       it != iterInfoRep.end() ;
       ++it ) {

    bioIteratorInfo info = (*it).second ;

    str << info.getCppType(err) << "*" << endl << "  " ; 
    str << "bioIteratorFactory::getIter_" << info.iteratorName ;
    str << "(patString indexName) {" << endl ;
    str << "    " << info.getCppType(err) << "* res =" << endl ;
    str << "      new " << info.getCppType(err) << "(indexName) ;" << endl ;
    str << "return res ;" << endl ;
    // str << 
  }

  return patString(str.str()) ;
}

