//-*-c++-*------------------------------------------------------------
//
// File name : bioIteratorInfoRepository.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Tue Jul 14 13:21:51 2009
//
//--------------------------------------------------------------------

#ifndef bioIteratorInfoRepository_h
#define bioIteratorInfoRepository_h

#include "bioIteratorInfo.h"
#include "bioIteratorSpan.h"
#include <map>

class bioIteratorInfoRepository {

public:
  /**!
     @return pointer to the single instance of the class
   */
  static bioIteratorInfoRepository* the() ;

 void addIteratorInfo(patString name, bioIteratorInfo ii, patError*& err) ;
  bioIteratorInfo* getIteratorInfo(patString name) ;

  patString debug(patError*& err) ;

  map<patString,bioIteratorInfo> getRepository() const ;

  void addNewRowId(patString indexName, patULong rowNumber) ;
  void computeRowPointers(patULong sampleSize, patError*& err) ;
  patBoolean isRowIterator(patString name) ;
  bioIteratorSpan getSublist(patULong index, patError*& err) ;
  void generateSublistsForThreads(patULong dataSize, patULong numberOfThreads,patError*& err) ;
  
private:

  bioIteratorInfoRepository() ;
  patString topIterator ;
  map<patString,bioIteratorInfo> theRepository ;
  vector<bioIteratorSpan> subListsForThreads ;
};

#endif
