//-*-c++-*------------------------------------------------------------
//
// File name : bioModel.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Mon Apr 27 15:41:49 2009
//
//--------------------------------------------------------------------

#ifndef bioModel_h
#define bioModel_h

#include "bioExpression.h"
#include <map>
/*!
Class defining a model in the general sense. 
*/

class bioModel {

public:
  bioModel();
  void setFormula(bioExpression* theFormula) ;
  void setExcludeExpr(bioExpression* excludeExpr) ;
  void setStatistics(map<patString, bioExpression*>* stat) ;
  void setConstraints(map<patString, bioExpression*>* constr) ;
  void setSimulation(bioExpression* simul) ;

  bioExpression* getFormula() ;
  bioExpression* getExcludeExpr() ;
  map<patString, bioExpression*>* getStatistics() ;
  map<patString, bioExpression*>* getConstraints() ;
  bioExpression* getSimulation() ;

  patBoolean mustEstimate() const ;
  patBoolean mustSimulate() const ;

protected:
  bioExpression* theFormula ;
  bioExpression* excludeExpr ;
  map<patString, bioExpression*>* statistics ;
  map<patString, bioExpression*>* constraints ;
  bioExpression* simulation ;

};


#endif
