//-*-c++-*------------------------------------------------------------
//
// File name : bioModelParser.h
// Author :    Michel Bierlaire and Mamy Fetiarison
// Date :      Thu May  7 09:52:29 2009
//
//--------------------------------------------------------------------

#ifndef bioModelParser_h
#define bioModelParser_h

#include <Python.h> // Before all other includes


#include "bioModel.h"
#include "bioLiteralRepository.h"

class bioExpression ;


class bioModelParser {
public:
	bioModelParser(const patString& fname) ;
	bioModel* readModel(patError*& err) ;
  void setSampleFile(patString f) ;
private:

  bioModel *theModel;
  patString filename;
  patString theDataFile ;
  bioExpression* buildExpression(PyObject* pExpression, patError*& err) ;
  bioExpression* getFormula(PyObject* pBioObject, patError*& err);
  map<patString, bioExpression*>* getStatistics(PyObject* pBioObject, patError*& err) ;
  bioExpression* getSimulation(PyObject* pBioObject, patError*& err) ;
  map<patString, bioExpression*>* getConstraints(PyObject* pBioObject, patError*& err) ;
  bioExpression* getExclude(PyObject* pBioObject, patError*& err) ;
  map<patString, patString>* getParameters(PyObject* pBioObject, patError*& err) ;

  void buildIteratorInfo(PyObject* pModule, patError*& err) ;

  bioLiteralRepository *repository;

};

#endif
